//
//  WKWebViewController.swift
//  exmp2_cd
//
//  Created by Mark Hunte on 10/07/2021.
//
 

import UIKit
import WebKit
import AVFoundation

class WKWebViewController: UIViewController, WKNavigationDelegate  ,WKScriptMessageHandler {
 
    
    //-- declare a WKWebView
    var webView: WKWebView!
    
    //-- declare a any vars
    var theContent :String = ""
    
    //-- declare a message name to use later
    let messageName = "setcont"
    let messageName2 = "helloworld"
    
    //-- declare a your html file  name to use later ( do not include the .html )
    let htmlName = "cdata"
    
    let moc =   ( UIApplication.shared.delegate as! AppDelegate).persistentContainer.viewContext
    
    var contentItems:[ScriptingSetting]?
    

    
    
    
      // MARK: - WKUserContentController:  -> webkit Posted messages handler delegate //-- handles messages from hype page
    func userContentController(_ userContentController: WKUserContentController, didReceive message: WKScriptMessage) {
        
        
        print("\(message.name )")
        
        //-- Posted messages  from Hype page
        if message.name ==  messageName {
            
            //-- Get the message passed to app
            theContent   =  message.body as! String
 
            
           // webView!.evaluateJavaScript("HYPE.documents['\(htmlName)'].getElementById('name').innerText = 'here I am'")
           
            fetchContent ()
        }
        
        if message.name ==  messageName2 {
            
            //-- Get the message passed to app
            theContent   =  message.body as! String
            self.contentItems?.first?.content  = theContent
            do {
                
            try self.moc.save()
                
            }
            catch {
                
            }
            
        }
        
      
    }
    
    
    
    override func viewDidLoad() {
        
        super.viewDidLoad()

        //-- configure the WKWebView
        
        //-- init config and controller
        let wconfiguration = WKWebViewConfiguration()
        let wcontroller = WKUserContentController()
        
//MARK: WKUserContentController Init :  We must add the webkit scripts Posted messages we expect to get from the Hype Page to the controller
        wcontroller.add(self, name:  messageName )
        wcontroller.add(self, name:  messageName2 )
        
        //-- attach controller, config to WKWebview
        wconfiguration.userContentController = wcontroller;
        
 
        wconfiguration.allowsInlineMediaPlayback = true
        wconfiguration.mediaTypesRequiringUserActionForPlayback = []
 
        
        webView =  WKWebView(frame: .zero, configuration: wconfiguration)
        

        let  theFileName = (htmlName as NSString).lastPathComponent
        let htmlPath = Bundle.main.path(forResource: theFileName, ofType: "html")
        
        let folderPath = Bundle.main.bundlePath
        
        let baseUrl = URL(fileURLWithPath: folderPath, isDirectory: true)
        
        do {
            
            let htmlString = try NSString(contentsOfFile: htmlPath!, encoding: String.Encoding.utf8.rawValue)
            
            webView.loadHTMLString(htmlString as String, baseURL: baseUrl)
            
        } catch {
            
            // catch error
            
        }
        
        webView.navigationDelegate = self
      
        webView.scrollView.bounces = false
        webView.scrollView.isScrollEnabled = false
        webView.isOpaque = false
        webView.isHidden = false
 
        view = webView
        
        fetchContent ()
    }
    
    
    func fetchContent (){
        
        // fetch data from core data
        do {
            self.contentItems =  try moc.fetch(ScriptingSetting.fetchRequest())
           
            //-- In Example we are only using 1 entry
          
            if self.contentItems?.first?.content! == ""  {
                
                //-- core data is empty  so use the content from the message
                
                let newContent = ScriptingSetting(context: self.moc)
                newContent.name = "content1"
                newContent.content = theContent
               
                
                do {
                    
                try self.moc.save()
                    
                }
                catch {
                    
                }
                
            } else {
                
                //-- if core data is NOT empty use the content from the message
                
                 print("\(String(describing: self.contentItems?.first?.content))")
                
                let st1 = self.contentItems?.first?.content!
                webView!.evaluateJavaScript("HYPE.documents['\(htmlName)'].getElementById('name').querySelector('textArea').value = '\(st1! )'")
                 
            }
        }
        catch {
            
        }
    }
    
    
//    // MARK: Action for the App to send message to Hype
//    @objc func selectorX(_ sender: UIBarButtonItem) {
//
//        webView!.evaluateJavaScript("HYPE.documents['\(htmlName)'].showSceneNamed('\(sender.title!)', HYPE.documents['\(htmlName)'].kSceneTransitionCrossfade, 0.2);", completionHandler:nil )
//
//        sender.title = ( sender.title  == "Scene 2" ? "Scene 1" : "Scene 2")
//
//
//    }
    
//    // MARK: Add navigationBar and buttons programmatically
//    override func viewWillLayoutSubviews() {
//
//        let startingYPos =   view.window?.windowScene?.statusBarManager?.statusBarFrame.height ?? 0
//
//        let width = self.view.frame.width
//        let navigationBar: UINavigationBar = UINavigationBar(frame: CGRect(x: 0, y: startingYPos, width: width, height: 44))
//        self.view.addSubview(navigationBar);
//        let navigationItem = UINavigationItem(title: "Navigation bar")
//        let doneBtn = UIBarButtonItem(title: "Scene 2", style: UIBarButtonItem.Style.plain, target: nil, action: #selector(selectorX))
//
//        navigationItem.rightBarButtonItem = doneBtn
//        navigationBar.setItems([navigationItem], animated: false)
//
//
//    }
    
    
    
    
}

